﻿using System;
using System.Collections.Generic;
using System.Xml;
using System.Runtime.Remoting.Messaging;
using System.Reflection;

namespace Monk.Aop.Proxy
{
    internal static class AspectManager
    {
        static AspectManager()
        {
            try
            {
                XmlDocument doc = new XmlDocument();
                doc.Load("Monk.xml");
                XmlNodeList list = doc.SelectNodes("/Monk/Aop/ProxyAop/Aspect");
                foreach (XmlNode node in list)
                {
                    try
                    {
                        string type = node.Attributes["type"].Value + "," + node.Attributes["methodname"].Value;
                        string providertype = node.Attributes["providertype"].Value;
                        int index = providertype.IndexOf(',');
                        IAspectAdvice advice = Assembly.LoadFrom(providertype.Substring(0, index)).CreateInstance(providertype.Substring(index + 1)) as IAspectAdvice;
                        if (cache.ContainsKey(type))
                        {
                            cache[type].Add(advice);
                        }
                        else
                        {
                            cache.Add(type, new List<IAspectAdvice>() { advice});
                        }
                    }
                    catch { }
                }
            }
            catch { }
        }
        //缓存
        private static Dictionary<string, List<IAspectAdvice>> cache = new Dictionary<string, List<IAspectAdvice>>();
        //获取通知
        public static IAspectAdvice[] FindAspect(Type t, IMethodMessage msg)
        {
            if (msg == null)
            {
                return null;
            }
            string s = t.Assembly.ManifestModule.Name + "," + t.FullName + "," + msg.MethodName;
            if (cache.ContainsKey(s))
            {
                return cache[s].ToArray();
            }
            return null;
        }
    }
}
