﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Security.Permissions;
using System.Runtime.Remoting.Proxies;

namespace Monk.Aop.Proxy
{
    [AttributeUsage(AttributeTargets.Class)]
    [SecurityPermissionAttribute(SecurityAction.Demand, Flags = SecurityPermissionFlag.Infrastructure)]
    public sealed class AspectOrientedAttribute : ProxyAttribute
    {
        public AspectOrientedAttribute(){}
        public override MarshalByRefObject CreateInstance(Type serverType)
        {
            MarshalByRefObject mbro = base.CreateInstance(serverType);
            RealProxy realproxy = new AspectProxy(serverType, mbro);
            return realproxy.GetTransparentProxy() as MarshalByRefObject;
        }
    }
}
